// import 'package:flutter/material.dart';
// import 'package:flutter_bloc/flutter_bloc.dart';
// import 'package:hub/backend/api_requests/api_manager.dart';
// import 'package:hub/flutter_flow/nav/nav.dart';
// import 'package:hub/shared/utils/dialog_util.dart';
// import 'package:hub/shared/utils/log_util.dart';

// class HistoryBloc extends Bloc<HistoryEvent, HistoryState> {
//   final ScrollController scrollController = ScrollController();
//   final Future<ApiCallResponse> Function(int pageSize, int pageNumber, Map<String, String> opt) fetchHistoryService;
//   final bool Function(dynamic item, Map<String, String> opt)? filterLogic;

//   HistoryBloc(Map<String, String> opt, this.fetchHistoryService, {this.filterLogic}) : super(HistoryState(opt: opt)) {
//     scrollController.addListener(_onScroll);
//     on<UpdateHistoryEvent>(_onUpdateHistory);
//     on<FetchHistoryEvent>(_onFetchHistory);
//     add(FetchHistoryEvent());
//   }

//   void _onScroll() {
//     if (scrollController.position.atEdge && scrollController.position.pixels != 0) {
//       add(FetchHistoryEvent());
//     }
//   }

//   Future<void> _onUpdateHistory(UpdateHistoryEvent event, Emitter<HistoryState> emit) async {
//     emit(state.copyWith(opt: event.newOpt, historyWrap: [], pageNumber: 1));
//     add(FetchHistoryEvent());
//   }

//   Future<void> _onFetchHistory(FetchHistoryEvent event, Emitter<HistoryState> emit) async {
//     if (state.loading) return;
//     emit(state.copyWith(loading: true));
//     try {
//       var response = await fetchHistoryService(state.pageSize, state.pageNumber, state.opt);

//       final List<dynamic> history = response.jsonBody['acessos'] ?? [];
//       List<dynamic> filteredHistory = history.where((item) {
//         if (filterLogic != null) {
//           return filterLogic!(item, state.opt);
//         } else {
//           return true;
//         }
//       }).toList();

//       if (filteredHistory.isNotEmpty) {
//         emit(state.copyWith(
//           historyWrap: [...state.historyWrap, ...filteredHistory],
//           hasData: true,
//           loading: false,
//           pageNumber: state.pageNumber + 1,
//         ));
//       } else {
//         emit(state.copyWith(hasData: false, loading: false));
//       }
//     } catch (e, s) {
//       await DialogUtil.errorDefault(navigatorKey.currentContext!);
//       LogUtil.requestAPIFailed('processRequest', "", "Fetch History", e, s);
//       emit(state.copyWith(hasData: false, loading: false, error: e.toString()));
//     }
//   }

//   @override
//   Future<void> close() {
//     scrollController.dispose();
//     return super.close();
//   }
// }

// class HistoryState {
//   final Map<String, String> opt;
//   final List<dynamic> historyWrap;
//   final bool hasData;
//   final bool loading;
//   final int pageNumber;
//   final int pageSize;
//   final String? error;

//   HistoryState({
//     required this.opt,
//     this.historyWrap = const [],
//     this.hasData = false,
//     this.loading = false,
//     this.pageNumber = 1,
//     this.pageSize = 10,
//     this.error,
//   });

//   HistoryState copyWith({
//     Map<String, String>? opt,
//     List<dynamic>? historyWrap,
//     bool? hasData,
//     bool? loading,
//     int? pageNumber,
//     int? pageSize,
//     String? error,
//   }) {
//     return HistoryState(
//       opt: opt ?? this.opt,
//       historyWrap: historyWrap ?? this.historyWrap,
//       hasData: hasData ?? this.hasData,
//       loading: loading ?? this.loading,
//       pageNumber: pageNumber ?? this.pageNumber,
//       pageSize: pageSize ?? this.pageSize,
//       error: error ?? this.error,
//     );
//   }
// }

// abstract class HistoryEvent {}

// class UpdateHistoryEvent extends HistoryEvent {
//   final Map<String, String> newOpt;
//   UpdateHistoryEvent(this.newOpt);
// }

// class FetchHistoryEvent extends HistoryEvent {}
