// import 'dart:developer';

// import 'package:flutter/material.dart';
// import 'package:flutter_bloc/flutter_bloc.dart';
// import 'package:google_fonts/google_fonts.dart';
// import 'package:hub/features/history/index.dart';
// import 'package:hub/flutter_flow/internationalization.dart';
// import 'package:hub/flutter_flow/nav/nav.dart';
// import 'package:hub/backend/api_requests/api_manager.dart';
// import 'package:hub/flutter_flow/flutter_flow_theme.dart';
// import 'package:hub/shared/utils/dialog_util.dart';
// import 'package:hub/shared/utils/log_util.dart';
// import 'package:hub/flutter_flow/flutter_flow_icon_button.dart';

// class HistoryPageTemplate extends StatelessWidget {
//   final Map<String, String> opt;
//   final Future<ApiCallResponse> Function(int pageSize, int pageNumber, Map<String, String> opt) fetchHistoryService;
//   final Widget Function(BuildContext context, dynamic historyItem) cardBuilder;
//   final String appBarTitle;
//   final String noHistoryMessage;
//   final String errorMessage;
//   final bool isLeading;
//   final bool isFilter;
//   final bool Function(dynamic item, Map<String, String> opt)? filterLogic;

//   const HistoryPageTemplate({
//     Key? key,
//     required this.opt,
//     required this.fetchHistoryService,
//     required this.cardBuilder,
//     this.appBarTitle = 'History',
//     this.noHistoryMessage = 'No history found!',
//     this.errorMessage = 'Failed to perform operation!',
//     this.isLeading = true,
//     this.isFilter = false,
//     this.filterLogic,
//   }) : super(key: key);

//   @override
//   Widget build(BuildContext context) {
//     return BlocProvider(
//       create: (context) => HistoryBloc(opt, fetchHistoryService, filterLogic: filterLogic),
//       child: HistoryPageView(
//         cardBuilder: cardBuilder,
//         appBarTitle: appBarTitle,
//         noHistoryMessage: noHistoryMessage,
//         errorMessage: errorMessage,
//         isLeading: isLeading,
//         isFilter: isFilter,
//       ),
//     );
//   }
// }

// class HistoryPageView extends StatelessWidget {
//   final Widget Function(BuildContext context, dynamic historyItem) cardBuilder;
//   final String appBarTitle;
//   final String noHistoryMessage;
//   final String errorMessage;
//   final bool isLeading;
//   final bool isFilter;

//   const HistoryPageView({
//     Key? key,
//     required this.cardBuilder,
//     required this.appBarTitle,
//     required this.noHistoryMessage,
//     required this.errorMessage,
//     this.isLeading = false,
//     this.isFilter = false,
//   }) : super(key: key);

//   @override
//   Widget build(BuildContext context) {
//     final theme = FlutterFlowTheme.of(context);
//     return Scaffold(
//       key: GlobalKey<ScaffoldState>(),
//       backgroundColor: theme.primaryBackground,
//       appBar: _buildAppBar(context, theme),
//       body: _buildBody(context),
//     );
//   }

//   PreferredSizeWidget _buildAppBar(BuildContext context, FlutterFlowTheme theme) {
//     return AppBar(
//       backgroundColor: theme.primaryBackground,
//       automaticallyImplyLeading: false,
//       leading: isLeading ? _buildBackButton(context, theme) : null,
//       title: _buildTitle(context, theme),
//       centerTitle: true,
//       elevation: 0.0,
//       actions: [
//         if (isFilter) _buildFilterButton(context),
//       ],
//     );
//   }

//   Widget _buildBackButton(BuildContext context, FlutterFlowTheme theme) {
//     return FlutterFlowIconButton(
//       borderColor: Colors.transparent,
//       borderRadius: 30.0,
//       borderWidth: 1.0,
//       buttonSize: 60.0,
//       icon: Icon(
//         Icons.keyboard_arrow_left,
//         color: theme.primaryText,
//         size: 30.0,
//       ),
//       onPressed: () => Navigator.of(context).pop(),
//     );
//   }

//   Widget _buildTitle(BuildContext context, FlutterFlowTheme theme) {
//     return Text(
//       appBarTitle,
//       style: theme.headlineMedium.override(
//         fontFamily: theme.headlineMediumFamily,
//         color: theme.primaryText,
//         fontSize: 16.0,
//         letterSpacing: 0.0,
//         useGoogleFonts: GoogleFonts.asMap().containsKey(theme.headlineMediumFamily),
//       ),
//     );
//   }

//   Widget _buildFilterButton(BuildContext context) {
//     return Row(
//       mainAxisAlignment: MainAxisAlignment.end,
//       children: [
//         Padding(
//           padding: const EdgeInsets.fromLTRB(0, 0, 10, 0),
//           child: IconButton(
//             icon: const Icon(Icons.filter_list),
//             onPressed: () async {
//               final Map<String, String>? selectedFilter = await showModalBottomSheet<Map<String, String>>(
//                 isScrollControlled: true,
//                 backgroundColor: Colors.transparent,
//                 context: context,
//                 builder: (BuildContext bottomSheetContext) {
//                   return GestureDetector(
//                     onTap: () => Navigator.of(bottomSheetContext).pop(),
//                     child: Container(
//                       color: Colors.transparent,
//                       child: GestureDetector(
//                         onTap: () {},
//                         child: FilterModalWidget(
//                           defaultSelections: {
//                             'personType': context.read<HistoryBloc>().state.opt['personType'] == '.*' ? ['E', 'O'] : [context.read<HistoryBloc>().state.opt['personType']],
//                             'search': '.*',
//                           },
//                           filterOptions: {
//                             'personType': [
//                               {
//                                 'title': FFLocalizations.of(context).getVariableText(ptText: 'Visitante', enText: 'Visitor'),
//                                 'value': 'E',
//                               },
//                               {
//                                 'title': FFLocalizations.of(context).getVariableText(ptText: 'Morador', enText: 'Resident'),
//                                 'value': 'O',
//                               },
//                             ],
//                           },
//                           filterTitles: {
//                             'personType': 'Person Type',
//                           },
//                         ),
//                       ),
//                     ),
//                   );
//                 },
//               );

//               if (selectedFilter != null) {
//                 context.read<HistoryBloc>().add(UpdateHistoryEvent(selectedFilter));
//               }
//             },
//           ),
//         ),
//       ],
//     );
//   }

//   Widget _buildBody(BuildContext context) {
//     return BlocBuilder<HistoryBloc, HistoryState>(
//       builder: (context, state) {
//         log('state: ${state.historyWrap}');
//         if (state.loading && state.historyWrap.isEmpty) {
//           return Center(
//             child: CircularProgressIndicator(
//               valueColor: AlwaysStoppedAnimation<Color>(
//                 FlutterFlowTheme.of(context).primary,
//               ),
//             ),
//           );
//         } else if (state.error != null) {
//           return Center(
//             child: Text(errorMessage),
//           );
//         } else if (state.historyWrap.isEmpty) {
//           return Center(
//             child: Text(noHistoryMessage),
//           );
//         } else {
//           return ListView.builder(
//             shrinkWrap: true,
//             physics: const BouncingScrollPhysics(),
//             controller: context.read<HistoryBloc>().scrollController,
//             itemCount: state.historyWrap.length,
//             itemBuilder: (context, index) {
//               final historyItem = state.historyWrap[index];
//               return cardBuilder(context, historyItem);
//             },
//           );
//         }
//       },
//     );
//   }
// }
